package de.antonfluegge.android.yubnubwidgetadfree;

import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;
import org.xmlpull.v1.XmlPullParserFactory;

//import com.tecnick.htmlutils.htmlentities.HTMLEntities;

import de.antonfluegge.android.yubnubwidgetadfree.R;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.text.Editable;
import android.text.Html;
import android.text.TextWatcher;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.WindowManager;
import android.view.inputmethod.EditorInfo;
import android.widget.ArrayAdapter;
import android.widget.TextView;
import android.widget.TextView.OnEditorActionListener;
import 	android.widget.AutoCompleteTextView;

public class SearchEditActivity extends Activity implements OnClickListener, OnEditorActionListener, TextWatcher {
	
	private CharSequence currentCommand = "";
	private AsyncTask<URL, Integer, String[]> updateManTask = null;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.search_layout);
		View text = findViewById(R.id.YubnubSearchText);
		((TextView) text).setOnEditorActionListener(this);
		((TextView) text).addTextChangedListener(this);
		
		// Set autocomplete adapter
		//String[] commands = getResources().getStringArray(R.array.yubnub_commands);
		//ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, R.layout.list_item, commands);
		//((AutoCompleteTextView) text).setAdapter(adapter);
	    //((AutoCompleteTextView) text).setThreshold(1);

		new ReadCommandsText().execute(this);
	    

	}
	
    public void beforeTextChanged(CharSequence s, int start, int count, int after){}
    public void onTextChanged(CharSequence s, int start, int before, int count){}
	@Override
	public void afterTextChanged(Editable text) {
		   Pattern p = Pattern.compile(" ");
		   String[] tokens = p.split(text.toString(),-1);
		   //Toast toast = Toast.makeText(this, tokens[0], Toast.LENGTH_SHORT);
		   //toast.show();
		   
		   View manText = findViewById(R.id.YubnubManText);
		   View manURL = findViewById(R.id.YubnubManURL);
			   int i = 0;
			   while (tokens[i].length()==0&&i<tokens.length-1)
				   i++;
			   if (tokens.length>i+1) {
			   if (tokens[i].compareTo((currentCommand.toString()))!=0) {
						   currentCommand = tokens[i];

						   
						   if(isConnected()) {
						   URL url = null;
						try {
							url = new URL("http://yubnub.org/kernel/man?args="+currentCommand);
						} catch (MalformedURLException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
						if (updateManTask!=null) {
							updateManTask.cancel(true);
						}
						updateManTask = new UpdateManText().execute(url);


						   } else {
							   if (updateManTask!=null) {
									updateManTask.cancel(true);
								}
							   ((TextView) manURL).setText("");
							   ((TextView) manText).setText("");
						   }
					 
				} 
		    } else {
		    	if (updateManTask!=null) {
					updateManTask.cancel(true);
				}
		    	currentCommand = "";
				   ((TextView) manURL).setText("");
				   ((TextView) manText).setText("");
		    }
	}
	
	public void onWindowFocusChanged (boolean hasFocus) {
		super.onWindowFocusChanged(hasFocus);
		if (hasFocus)
			this.getWindow().setSoftInputMode( 
	               WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_VISIBLE);
	}

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		View text = findViewById(R.id.YubnubSearchText);
		String urlStr = "http://www.yubnub.org/parser/parse?command="+((TextView) text).getText();  
		URL url;
		Intent i;
		try {
			url = new URL(urlStr);

			URI uri;
			try {
				uri = new URI(url.getProtocol(), url.getUserInfo(), url.getHost(), url.getPort(), url.getPath(), url.getQuery(), url.getRef());
				url = uri.toURL();
			} catch (URISyntaxException e) {
				e.printStackTrace();
			}
			i = new Intent(Intent.ACTION_VIEW,Uri.parse(url.toString())); 
			i.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
			startActivity(i);
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
	    // Handle item selection
	    switch (item.getItemId()) {
	        case R.id.about:
	        	Intent j = new Intent(this, AboutActivity.class);
	    		j.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
	    		j.setData(Uri.parse(j.toUri(Intent.URI_INTENT_SCHEME)));
	    		startActivity(j);
	            return true;
	        default:
	            return super.onOptionsItemSelected(item);
	    }
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
	    MenuInflater inflater = getMenuInflater();
	    inflater.inflate(R.menu.yubnub_menu, menu);
	    return true;
	}
	
	public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
		   if ((actionId == EditorInfo.IME_NULL || actionId == EditorInfo.IME_ACTION_SEARCH ||
	                actionId == EditorInfo.IME_ACTION_DONE)  ||
	                (event.getAction() == KeyEvent.ACTION_DOWN && 
	                event.getKeyCode() == KeyEvent.KEYCODE_ENTER)) { 
		      onClick(v);
		   }

		   return true;
		}
	
	/**
	* Check the network state
	* @param context context of application
	* @return true if the phone is connected
	*/
	public boolean isConnected() {
	    ConnectivityManager cm = (ConnectivityManager) getSystemService(CONNECTIVITY_SERVICE);
	    NetworkInfo netInfo = cm.getActiveNetworkInfo();
	    if (netInfo != null && netInfo.isConnected()) {
	        return true;
	    }
	    return false;
	}


	private class UpdateManText extends AsyncTask<URL, Integer, String[]> {
	     protected String[] doInBackground(URL... urls) {
	         int count = urls.length;
	         String[] text = new String[2];
	         for (int i = 0; i < count; i++) {
	  		   
				   InputStream is = null;
				try {
					is = urls[i].openStream();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				   int ptr = 0;
				   StringBuffer buffer = new StringBuffer();
				   if (is!=null) {
				   try {
					while ((ptr = is.read()) != -1) {
					       buffer.append((char)ptr);
					   }
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} }
				   if (currentCommand.length()==0) {
					   text[0] = "";
					   text[1] = "";
				   } else {					   
				   Pattern p = Pattern.compile("<span class=\"muted\">(.*?)</span>",Pattern.DOTALL);
				   Matcher m = p.matcher(buffer);
				   if (m.find()) {
					   text[0] = m.group(1);
				   } else {
					   text[0] = "no such command could be found";
				   }
				   p = Pattern.compile("<pre>(.*?)</pre>",Pattern.DOTALL);
				   m = p.matcher(buffer);
				   if (m.find()) {
					   text[1] = m.group(1);
				   } else {
					   text[1] = "";
				   } 
				   }
	         } 
	         return text; 
	     }
	     protected void onPostExecute(String[] result) {
	    	 View manText = findViewById(R.id.YubnubManText);
			 View manURL = findViewById(R.id.YubnubManURL);
			 ((TextView) manURL).setText(result[0]);
			 ((TextView) manText).setText(Html.fromHtml(result[1].replaceAll("\n", "<br />")));
			 //((TextView) manText).setText(HTMLEntities.unhtmlentities(HTMLEntities.unhtmlDoubleQuotes(HTMLEntities.unhtmlAngleBrackets(result[1]))));
	     }

	 }
	
	
	private class ReadCommandsText extends AsyncTask<Context, Integer, ArrayAdapter<String>> {
	     protected ArrayAdapter<String> doInBackground(Context... c) {
	    	 ArrayAdapter<String> adapter = new ArrayAdapter<String>(c[0], R.layout.list_item);
	 		
	 		InputStream istr = null;
	 		try {
	 			istr = getAssets().open("commands.xml");
	 		} catch (IOException e1) {
	 			// TODO Auto-generated catch block
	 			e1.printStackTrace();
	 		}
	 		  XmlPullParserFactory factory = null;
	 		try {
	 			factory = XmlPullParserFactory.newInstance();
	 		} catch (XmlPullParserException e1) {
	 			// TODO Auto-generated catch block
	 			e1.printStackTrace();
	 		} 
	 		  factory.setNamespaceAware(true); 
	 		  XmlPullParser xpp = null;
	 		try {
	 			xpp = factory.newPullParser();
	 		} catch (XmlPullParserException e1) {
	 			// TODO Auto-generated catch block
	 			e1.printStackTrace();
	 		}
	 		try {
	 			xpp.setInput(istr, "UTF-8");
	 		} catch (XmlPullParserException e1) {
	 			// TODO Auto-generated catch block
	 			e1.printStackTrace();
	 		}
	         int eventType = 0;
	 		try {
	 			eventType = xpp.getEventType();
	 		} catch (XmlPullParserException e) {
	 			// TODO Auto-generated catch block
	 			e.printStackTrace();
	 		}
	         while (eventType != XmlPullParser.END_DOCUMENT) {
	          if(eventType == XmlPullParser.TEXT)
	 			try {
	 				{
	 				     adapter.add(xpp.getText());
	 				 }
	 			} catch (Exception e) {
	 				// TODO Auto-generated catch block
	 				e.printStackTrace();
	 			}
	          try {
	 			eventType = xpp.next();
	 		} catch (XmlPullParserException e) {
	 			// TODO Auto-generated catch block
	 			e.printStackTrace();
	 		} catch (IOException e) {
	 			// TODO Auto-generated catch block
	 			e.printStackTrace();
	 		}
	         }
	         return adapter;
	     }
	     protected void onPostExecute(ArrayAdapter<String> adapter) {
	    	 View text = findViewById(R.id.YubnubSearchText);
	    	 ((AutoCompleteTextView) text).setAdapter(adapter);
	 	    ((AutoCompleteTextView) text).setThreshold(1);
	 	   ((YubnubTextComplete) text).activateCompletion();
	     }

	 }

	
}
