package de.antonfluegge.android.yubnubwidgetadfree;

import de.antonfluegge.android.yubnubwidgetadfree.R;
import android.app.PendingIntent;
import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.widget.RemoteViews;

public class YubnubWidgetProvider extends AppWidgetProvider {
	
	public static String DE_ANTONFLUEGGE_YUBNUBWIDGET_YUBNUBBUTTONPRESS = "DE_ANTONFLUEGGE_YUBNUBWIDGET_YUBNUBBUTTONPRESS";
	public static String DE_ANTONFLUEGGE_YUBNUBWIDGET_YUBNUBSEARCHPRESS = "DE_ANTONFLUEGGE_YUBNUBWIDGET_YUBNUBSEARCHPRESS";

	@Override
	public void onUpdate(Context context, AppWidgetManager appWidgetManager,
			int[] appWidgetIds) {
		for (int widgetId : appWidgetIds) {
     		RemoteViews views = new RemoteViews(context.getPackageName(),
					R.layout.widget_layout);
			views.setTextViewText(R.id.YubnubText, context.getString(R.string.short_name));
			// set intent and register onclick
			Intent i = new Intent(context, YubnubWidgetProvider.class);
			i.setAction(DE_ANTONFLUEGGE_YUBNUBWIDGET_YUBNUBBUTTONPRESS);
			PendingIntent pi = PendingIntent.getBroadcast(context,0, i,0);
			views.setOnClickPendingIntent(R.id.YubnubButton,pi);
			Intent j = new Intent(context, YubnubWidgetProvider.class);
			j.setAction(DE_ANTONFLUEGGE_YUBNUBWIDGET_YUBNUBSEARCHPRESS);
			PendingIntent pj = PendingIntent.getBroadcast(context,0, j,0);
			views.setOnClickPendingIntent(R.id.YubnubSearch,pj);
/*			Intent j = new Intent(context, SearchEditActivity.class);
			j.putExtra(AppWidgetManager.EXTRA_APPWIDGET_ID, widgetId);  // Identifies the particular widget...
			j.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
			// Make the pending intent unique...
			j.setData(Uri.parse(j.toUri(Intent.URI_INTENT_SCHEME)));
			PendingIntent pj = PendingIntent.getActivity(context, 0, j, PendingIntent.FLAG_UPDATE_CURRENT);
			views.setOnClickPendingIntent(R.id.YubnubSearch, pj);*/

			
			
			appWidgetManager.updateAppWidget(widgetId, views);
		}
	}
	
	@Override
	public void onReceive(Context context, Intent intent) {
			AppWidgetManager appWidgetManager = AppWidgetManager.getInstance(context);
			ComponentName thisAppWidget = new ComponentName("de.antonfluegge.android.yubnubwidget", "de.antonfluegge.android.yubnubwidget"+"."+"YubnubWidgetProvider");
			int[] appWidgetIds = appWidgetManager.getAppWidgetIds(thisAppWidget);
			try {
				onUpdate(context, appWidgetManager, appWidgetIds);
			} catch (Exception e) {
				e.printStackTrace();
			}
			super.onReceive(context, intent);

			if (intent.getAction().equals(DE_ANTONFLUEGGE_YUBNUBWIDGET_YUBNUBBUTTONPRESS)) {
				//do some really cool stuff here
				String url = "http://www.yubnub.org/parser/parse?command="+context.getString(R.string.short_name);  
				Intent i = new Intent(Intent.ACTION_VIEW);  
				i.setData(Uri.parse(url)); 
				i.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
				context.startActivity(i);
			}

			if (intent.getAction().equals(DE_ANTONFLUEGGE_YUBNUBWIDGET_YUBNUBSEARCHPRESS)) {
				Intent j = new Intent(context, SearchEditActivity.class);
				j.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
				// Make the pending intent unique...
				j.setData(Uri.parse(j.toUri(Intent.URI_INTENT_SCHEME)));
				context.startActivity(j);
			}
	} 
}

